from fastapi import APIRouter, Request, Form
from fastapi.responses import RedirectResponse, HTMLResponse
from icecream import ic

from classes.constraints import Constraints
from .db import Database

router = APIRouter()


# external api
@router.get('/api/user/{username}')
async def get_api(request: Request, username: str):
    if not Database.Users.get_address(username):
        return {'error': 'invalid user'}
    return Database.Users.get_address(username)


@router.get('/api/all')
async def get_api_all(request: Request):
    return Database.Users.get_all()


# site search redirect
@router.get('/search')
async def search_api(request: Request):
    username = request.query_params['username']
    ic(request.query_params.get('switch', None) == 'on')
    if request.query_params.get('switch', None) == 'on':
        return RedirectResponse(f'/yellwowpage/matches/{username}')
    else:
        return RedirectResponse(f'/yellwowpage/user/{username}')
