from fastapi import APIRouter, Request
from fastapi.responses import RedirectResponse, HTMLResponse
from icecream import ic

from classes.constraints import Constraints
from .db import Database

router = APIRouter()


@router.get('/yellwowpage')
async def get_yellwowpage(request: Request):
    return Constraints.templates.TemplateResponse('/yellwow/index.html',
                                                  {'request': request, 'user_data': Database.Users.get_all()})


@router.get('/yellwowpage/user/{username}')
async def get_yellwowpage(request: Request, username: str):
    return Constraints.templates.TemplateResponse('/yellwow/single_user/index.html',
                                                  {'request': request,
                                                   'user_data': Database.Users.get_address(username)})


@router.get('/yellwowpage/matches/{username}')
async def get_yellwowpage_matches(request: Request, username: str):
    ic(Database.Users.get_matches(username))
    return Constraints.templates.TemplateResponse('/yellwow/single_user/index.html',
                                                  {'request': request,
                                                   'user_data': Database.Users.get_matches(username)})


@router.get('/about')
async def get_about(request: Request):
    return Constraints.templates.TemplateResponse('/about/index.html', {'request': request})


@router.get('/about/api')
async def get_api_about(request: Request):
    return Constraints.templates.TemplateResponse('/about/api/index.html', {'request': request})
